Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.pattern
Class NodeTest

    java.lang.Object
      net.sf.saxon.pattern.NodeTest

All Implemented Interfaces:
  ItemType, java.io.Serializable

Direct Known Subclasses:
  AnyChildNodePattern, AnyNodeTest, CombinedNodeTest, ContentTypeTest, DocumentNodeTest, LocalNameTest, NamespaceTest, NameTest, NodeKindTest, NoNodeTest, SubstitutionGroupTest

public abstract class NodeTest
extends java.lang.Object
implements ItemType, java.io.Serializable

A NodeTest is a simple kind of pattern that enables a context-free test of whether a node has a particular name. There are several kinds of node test: a full name test, a prefix test, and an "any node of a given type" test, an "any node of any type" test, a "no nodes" test (used, e.g. for "@comment()").

As well as being used to support XSLT pattern matching, NodeTests act as predicates in axis steps, and also act as item types for type matching.

See Also:
  Serialized Form

Constructor Summary
`NodeTest()`

Method Summary
`AtomicType` | `getAtomizedItemType()` Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)
`SchemaType` | `getContentType()` Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes).
`abstract double` | `getDefaultPriority()` Determine the default priority of this node test when used on its own as a Pattern
`int` | `getFingerprint()` Get the name of the nodes matched by this nodetest, if it matches a specific name.
`abstract int` | `getNodeKindMask()` Get a mask indicating which kinds of nodes this NodeTest can match.
`ItemType` | `getPrimitiveItemType()` Get the primitive item type corresponding to this item type.
`int` | `getPrimitiveType()` Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.
`IntHashSet` | `getRequiredNodeNames()` Get the set of node names allowed by this NodeTest.
`ItemType` | `getSuperType(TypeHierarchy th)` Get the type from which this item type is derived by restriction.
`boolean` | `isAtomicType()` Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)
`abstract boolean` | `matches(int nodeKind, int fingerprint, int annotation)` Test whether this node test is satisfied by a given node.
`abstract boolean` | `matches(NodeInfo node)` Test whether this node test is satisfied by a given node.
`abstract boolean` | `matches(TinyTree tree, int nodeNr)` Test whether this node test is satisfied by a given node on a TinyTree.
`boolean` | `matchesItem(Item item, XPathContext context, boolean allowURIPromotion)` Test whether a given item conforms to this type.
`java.lang.String` | `toString(NamePool pool)` Display the type descriptor for diagnostics

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### NodeTest

    public NodeTest()

Method Detail

### matchesItem

    public boolean matchesItem(Item item,
                               XPathContext context,
                               boolean allowURIPromotion)

  Test whether a given item conforms to this type. This implements a method of the ItemType interface.

  Specified by:
    `matchesItem` in interface `ItemType`
  Parameters:
    `item` - The item to be tested
    `context` -
    `allowURIPromotion` -
  Returns:
    true if the item is an instance of this type; false otherwise

### getSuperType

    public ItemType getSuperType(TypeHierarchy th)

  Get the type from which this item type is derived by restriction. This is the supertype in the XPath type heirarchy, as distinct from the Schema base type: this means that the supertype of xs:boolean is xdt:anyAtomicType, whose supertype is item() (rather than xs:anySimpleType).

  In fact the concept of "supertype" is not really well-defined, because the types form a lattice rather than a hierarchy. The only real requirement on this function is that it returns a type that strictly subsumes this type, ideally as narrowly as possible.

  Specified by:
    `getSuperType` in interface `ItemType`
  Parameters:
    `th` -
  Returns:
    the supertype, or null if this type is item()

### getDefaultPriority

    public abstract double getDefaultPriority()

  Determine the default priority of this node test when used on its own as a Pattern

### getPrimitiveItemType

    public ItemType getPrimitiveItemType()

  Get the primitive item type corresponding to this item type. For item(), this is Type.ITEM. For node(), it is Type.NODE. For specific node kinds, it is the value representing the node kind, for example Type.ELEMENT. For anyAtomicValue it is Type.ATOMIC_VALUE. For numeric it is Type.NUMBER. For other atomic types it is the primitive type as defined in XML Schema, except that INTEGER is considered to be a primitive type.

  Specified by:
    `getPrimitiveItemType` in interface `ItemType`

### getPrimitiveType

    public int getPrimitiveType()

  Get the basic kind of object that this ItemType matches: for a NodeTest, this is the kind of node, or Type.Node if it matches different kinds of nodes.

  Specified by:
    `getPrimitiveType` in interface `ItemType`
  Returns:
    the node kind matched by this node test

### getFingerprint

    public int getFingerprint()

  Get the name of the nodes matched by this nodetest, if it matches a specific name. Return -1 if the node test matches nodes of more than one name

### isAtomicType

    public boolean isAtomicType()

  Determine whether this item type is atomic (that is, whether it can ONLY match atomic values)

  Specified by:
    `isAtomicType` in interface `ItemType`
  Returns:
    false: this is not ANY_ATOMIC_TYPE or a subtype thereof

### getAtomizedItemType

    public AtomicType getAtomizedItemType()

  Get the item type of the atomic values that will be produced when an item of this type is atomized (assuming that atomization succeeds)

  Specified by:
    `getAtomizedItemType` in interface `ItemType`

### matches

    public abstract boolean matches(TinyTree tree,
                                    int nodeNr)

  Test whether this node test is satisfied by a given node on a TinyTree. The node must be a document, element, text, comment, or processing instruction node. This method is provided so that when navigating a TinyTree a node can be rejected without actually instantiating a NodeInfo object.

  Parameters:
    `tree` - the TinyTree containing the node
    `nodeNr` - the number of the node within the TinyTree
  Returns:
    true if the node matches the NodeTest, otherwise false

### matches

    public abstract boolean matches(int nodeKind,
                                    int fingerprint,
                                    int annotation)

  Test whether this node test is satisfied by a given node. This method is only fully supported for a subset of NodeTests, because it doesn't provide all the information needed to evaluate all node tests. In particular (a) it can't be used to evaluate a node test of the form element(N,T) or schema-element(E) where it is necessary to know whether the node is nilled, and (b) it can't be used to evaluate a node test of the form document-node(element(X)). This in practice means that it is used (a) to evaluate the simple node tests found in the XPath 1.0 subset used in XML Schema, and (b) to evaluate node tests where the node kind is known to be an attribute.

  Parameters:
    `nodeKind` - The kind of node to be matched
    `fingerprint` - identifies the expanded name of the node to be matched. The value should be -1 for a node with no name.
    `annotation` - The actual content type of the node

### matches

    public abstract boolean matches(NodeInfo node)

  Test whether this node test is satisfied by a given node. This alternative method is used in the case of nodes where calculating the fingerprint is expensive, for example DOM or JDOM nodes.

  Parameters:
    `node` - the node to be matched

### getNodeKindMask

    public abstract int getNodeKindMask()

  Get a mask indicating which kinds of nodes this NodeTest can match. This is a combination of bits: 1<

### getContentType

    public SchemaType getContentType()

  Get the content type allowed by this NodeTest (that is, the type annotation of the matched nodes). Return AnyType if there are no restrictions. The default implementation returns AnyType.

### getRequiredNodeNames

    public IntHashSet getRequiredNodeNames()

  Get the set of node names allowed by this NodeTest. This is returned as a set of Integer fingerprints. A null value indicates that all names are permitted (i.e. that there are no constraints on the node name. The default implementation returns null.

### toString

    public java.lang.String toString(NamePool pool)

  Display the type descriptor for diagnostics

  Specified by:
    `toString` in interface `ItemType`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD